//+------------------------------------------------------------------+
//|                                          Open-Range-Breakout.mq4 |
//|                                                          JustiZe |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "JustiZe"
#property link      ""


extern string Set1 = "Trade-Zeitraum";
extern int    MaxOrderTime_h= 24;   // Zeit in Stunden-Bars
extern string Set2 = "Stopp-Parameter";  
extern double Trailing_stop = 40;

datetime TradeTime;


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
  // Variablen fr die letzten Hochs
  double hoch1, hoch2, hoch3;
  // Variablen fr die letzten drei Tiefs
  double tief1, tief2, tief3;
  // Variablen fr die Min/Max
  double hoch, tief;
  // Variable fr Volatilitt
  double vola;
  // Variablen fr Kaufen/Verkaufen-Tag
  int kauftag    = 0;
  int verkauftag = 0;
  // Variablen fr Stopp-Order-Preisbildung
  double kauf_stopp_preis = 0;
  double verkauf_stopp_preis = 0;
  // Ma der durchschnittlichen Spanne
  double spanne = 0;
  // Variable fr wahre Spanne
  double wahre_spanne = 0;
  // Variable fr anfnglichen Stopp
  double anfangs_stopp = 0;
  // Variable zur Ermittlung der dreifachen Spanne
  int go_bep_long = 0; //BEP in Long?
  int go_bep_short = 0;//BEP in Short?
  int bep_stopp = 0;
  // Variable fr nahen Stopp
  double naher_stopp;
  
  // Ordervariablen, Systemvariablen...
  int ticket = 0;
  int total = 0;
  double lots = 0.1;
  double take_profit = 100;
  int magic_number1 = 1234;
  int magic_number2 = 1235;
  int cnt = 0;
  
  //====================================================================
  //Berechne das hchste Hoch und das tiefste Tief der letzten drei Tage
  //und lege den Unterschied zwischen den beiden Punkten als Ma der
  //Volatilitt fest.
  //====================================================================
  
  // Variablen fllen
  hoch1 = High[1]; 
  hoch2 = High[2];
  hoch3 = High[3];
  tief1 = Low[1];
  tief2 = Low[2];
  tief3 = Low[3];
  // Maximum / Minimum bestimmen
  if(hoch1 >= hoch2 && hoch1 >= hoch3) hoch = hoch1;
  if(hoch2 >= hoch1 && hoch2 >= hoch3) hoch = hoch2;
  if(hoch3 >= hoch1 && hoch3 >= hoch2) hoch = hoch3;
  if(tief1 <= tief2 && tief1 <= tief3) tief = tief1;
  if(tief2 <= tief1 && tief2 <= tief3) tief = tief2;
  if(tief3 <= tief1 && tief3 <= tief2) tief = tief3;
  // Unterschied bestimmen
  vola = hoch - tief;
  
  //=====================================================================
  //Stelle fest, ob morgen ein Leichter kaufen- oder ein leichter Verkau-
  //fen-Tag ist. Ist der heutige Schlusskurs gleich oder hher als der
  //gestrige Schlusskurs, dann ist morgen ein leichter Verkaufen-Tag. Ist
  //der heutige Schlusskurs  tiefer als der gestrige, dann ist morgen ein
  //leichter Kaufen-Tag
  //---------------------------------------------------------------------
  //Anmerkung:#
  //Zeitreihe um eins verschoben!!!
  //=====================================================================
  if(Close[1] >= Close[2]) verkauftag = 1;
  if(Close[1] <  Close[2]) kauftag    = 1;
  
  //=====================================================================
  //Ist heute ein leichter Kaufen-Tag, dann wird die Stopp-Order zum Kauf
  //folgendermaen berechnet: Teile das Ma der Volatilitt durch zwei 
  //und addiere das Ergebnis zum Erffnungskurs. Die Stopp-Order zum Ver-
  //kauf an einem leichten Kaufen-Tag wird ermittelt, indem das Ma der 
  //Volatilitt vom Erffnungskurs abgezogen wird.
  //=====================================================================
  if(verkauftag == 0 && kauftag == 1) // Kaufen-Tag?
    {
    kauf_stopp_preis    = vola/2 + Open[0];
    verkauf_stopp_preis = Open[0] - vola;
    }
  
  //=====================================================================
  //Ist heute ein leichter Verkaufen-Tag, dann wird die Stopp-Order zum
  //Verkauf folgendermaen berechnet: Teile das Ma der Volatilitt durch
  //zwei und ziehe das Ergebnis von Erffnungskurs ab. Die Stopp-Order 
  //zum Kauf an einem leichten Verkaufen-Tag wird ermittelt, indem das
  //Ma der Volatitilitt zum Erffnungskurs addiert wird.
  //=====================================================================
  if(verkauftag == 1 && kauftag == 0) // Verkaufen-Tag?
    {
    verkauf_stopp_preis = Open[0] - vola/2;
    kauf_stopp_preis    = Open[0] + vola;    
    }
  //=====================================================================
  //Anmerkung:
  //Runden der Werte!
  //=====================================================================
  verkauf_stopp_preis = MathRound(verkauf_stopp_preis);
  kauf_stopp_preis = MathRound(kauf_stopp_preis);
  
  //=====================================================================
  //Berechne die durchschnittliche wahre Spanne der letzten zehn Tage.
  //=====================================================================
  wahre_spanne = iATR(NULL,0,10,0);  
  
  //=====================================================================
  //Setze die dreifache durchschnittliche Spanne als anfnglichen Stopp.
  //=====================================================================
  anfangs_stopp = 3 * wahre_spanne;
  //=====================================================================
  //Anmerkung:
  //Runden des Wertes!
  //=====================================================================
  anfangs_stopp = MathRound(anfangs_stopp);
  
  //=====================================================================
  //Anmerkung:
  //Wenn flat, dann Orders in den Markt stellen.
  //Begrenzte Zeit fr Order hinzugefgt
  //=====================================================================
    // berprfung auf Signale und Handel
  total = OrdersTotal();    //Anzahl momentaner Order
    // Trade-Time-Management
  TradeTime = iTime(NULL,PERIOD_D1,0);
  
    // if-Block fr Einstieg
  if(total<2)               //total=0 : flat
    {
      ticket = OrderSend(Symbol(),OP_BUYSTOP, lots,kauf_stopp_preis*Point,   3,kauf_stopp_preis*Point - anfangs_stopp*Point,   0,NULL,magic_number1,TradeTime+MaxOrderTime_h*60*60,Blue);
      ticket = OrderSend(Symbol(),OP_SELLSTOP,lots,verkauf_stopp_preis*Point,3,verkauf_stopp_preis*Point + anfangs_stopp*Point,0,NULL,magic_number2,TradeTime+MaxOrderTime_h*60*60,Red);
      return(0);
    }
    
  //=====================================================================
  //Ist die Position um die dreifache durchschnittliche wahre Spanne in 
  //der Gewinnzone, ziehe den schtzenden Stopp auf den Kostendeckungs-
  //punkt nach.
  //=====================================================================
  //Vergleiche den Trailing-Stop, den schtzenden Stop und den Umkehrstop
  //un wende immer den Stopp an, der momentan dem Kurs am nchsten liegt.
  ///====================================================================
  
  for(cnt=0;cnt<total;cnt++)
    {
      wahre_spanne = iATR(NULL,0,10,0); 
      
      if(OrderSymbol()==Symbol() && OrderType() == OP_BUY)      
        {
          if((Close[0]-OrderOpenPrice())>=3*wahre_spanne && OrderStopLoss() != OrderOpenPrice())  // Stopp muss auf BreakEvenPoint nachgezogen werden
            {  
              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+(Ask-Bid),OrderTakeProfit(),0,Green); 
              return(0);
            } 
        }
      
      if(OrderSymbol()==Symbol() && OrderType() == OP_SELL)
        {  
          if((OrderOpenPrice()-Close[0])>=3*wahre_spanne && OrderStopLoss() == OrderOpenPrice())  // Stopp muss auf BreakEvenPoint nachgezogen werden
            {  
              OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()-(Ask-Bid),OrderTakeProfit(),0,Green); 
              return(0);
            }
        }
      
      
      naher_stopp = 30;
      //EDIT
      
    }
  

   return(0);
  }
//+------------------------------------------------------------------+